<!-- components/TextParser.vue -->
<template>
  <div>
    <label class="block mb-2">Enter text to parse:</label>
    <textarea v-model="text" class="border p-2 rounded w-full mb-4"
      :class="{ 'bg-gray-800 text-white border-gray-700': isDarkMode }" rows="4"></textarea>
    <button @click="parseText" class="px-4 py-2 rounded mr-2"
      :class="{ 'bg-blue-600 text-white': isDarkMode, 'bg-blue-500 text-white': !isDarkMode }">Parse</button>
    <button @click="queryText" class="px-4 py-2 rounded"
      :class="{ 'bg-green-600 text-white': isDarkMode, 'bg-green-500 text-white': !isDarkMode }">Query</button>
    <div class="grid grid-cols-2 gap-4 mt-4">
      <div>
        <h3 class="text-lg font-bold mb-2">Parsed Tree</h3>
        <pre class="p-4 rounded overflow-auto"
          :class="{ 'bg-gray-800 text-white': isDarkMode, 'bg-gray-100': !isDarkMode }">{{ parseResult }}</pre>
      </div>
      <div>
        <h3 class="text-lg font-bold mb-2">Query Output</h3>
        <pre class="p-4 rounded overflow-auto"
          :class="{ 'bg-gray-800 text-white': isDarkMode, 'bg-gray-100': !isDarkMode }">
          <vue-json-pretty :data="queryResult" @nodeClick="onNodeClick" />
        </pre>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from 'vue';
import type Parser from 'web-tree-sitter';
import VueJsonPretty from 'vue-json-pretty';
import 'vue-json-pretty/lib/styles.css';
import type { QueryCapture, SyntaxNode } from 'web-tree-sitter';

export default defineComponent({
  components: {
    VueJsonPretty,
  },
  name: 'TextParser',
  emits: ['node-clicked'],
  props: {
    parser: {
      type: Object as () => Parser | null,
      required: true,
    },
    query: {
      type: String,
      required: true,
    },
    selectedFields: {
      type: Array as () => string[],
      required: true,
    },
    isDarkMode: {
      type: Boolean,
      required: true,
    },
  },
  setup(props, { emit }) {
    const text = ref('');
    const parseResult = ref('');
    const queryResult = ref([] as QueryCapture[]);

    const parseText = () => {
      if (props.parser) {
        const tree = props.parser.parse(text.value);
        parseResult.value = tree.rootNode.toString();
      }
    };

    const queryText = () => {
      if (props.parser && props.query) {
        const tree = props.parser.parse(text.value);
        const query = props.parser.getLanguage().query(props.query);
        const captures = query.captures(tree.rootNode);
        queryResult.value = captures.map((capture) => {
          const result: { [key: string]: any } = {};
            for (const field of props.selectedFields) {
            result[field] = capture[field];
          };
          return result;
        });
      }
    };

    const onNodeClick = (node: any ) => {
      emit('node-clicked', node);
    };


    watch(
      () => props.parser,
      () => {
        parseResult.value = '';
        queryResult.value = [];
      }
    );

    watch(
      () => text.value,
      () => {
        parseText();
        queryText();
      }
    );

    return {
      text,
      parseResult,
      queryResult,
      parseText,
      queryText,
      onNodeClick
    };
  },
});
</script>